#!/bin/sh

# Don't use uninitialized vars
set -o nounset
# After here exit on any error
set -e

# current timestamp
DATETIME="$(date +%Y%m%d%H%M%S)"

# strict permissions
umask 077

# export all real database backends found to LDIF time-stamped files
{{ openldap_path.bin }}/ldapsearch \
  -Q \
  -LLL \
  -b 'cn=config' \
  -s one \
  '(olcSuffix=*)' \
  olcSuffix | \
  grep olcSuffix| \
  cut -d' ' -f2 | \
  xargs -n1 -isuffix \
    {{ openldap_path.slapd_exec }} -T cat \
      -f "{{ openldap_slapd_conf }}" \
      -b 'suffix' \
      -l "{{ openldap_backup_path }}/suffix-${DATETIME}.ldif"

# Remove old backup files
find "{{ openldap_backup_path }}" -type f -name "*.ldif*" -mtime +{{ openldap_backup_max_days }} -delete

{% if openldap_backup_compressor %}
# compress all uncompressed LDIF files
{{ openldap_backup_compressor }} {{ openldap_backup_path }}/*.ldif
{% endif %}
